/*
 * pnmtolips - PNM  LIPS 饹᡼ؤѴ
 *
 * 1997-09-30 Kouichi Hirabayashi
 */

#include <stdio.h>

int mag = 300;			/* magnifier */
int lmargin = 13;		/* left margin */
int fflg = 1;

char *cmd;
char buf[BUFSIZ];

main(argc, argv) char **argv;
{
  char *s;
  FILE *ifp, *efopen();

  cmd = argv[0];
  while (--argc > 0 && (*++argv)[0] == '-')
	for (s = argv[0]+1; *s; s++)
		switch (*s) {
		case 'M':
			if (s[1])
				s++;
			else {
				--argc;
				s = *++argv;
			}
			mag = atoi(s);
			s += strlen(s) - 1;
			break;
		case 'f':	/* inhibits form feed */
			fflg = 0;
			break;
		case 'm':
			if (s[1])
				s++;
			else {
				--argc;
				s = *++argv;
			}
			lmargin = atoi(s) / 8;
			s += strlen(s) - 1;
			break;
		default:
			Usage();
			exit(1);
		}

  if (argc > 0) {
	do {
		ifp = efopen(*argv, "r");
		convert(ifp);
		++argv;
	} while (--argc > 0);
  }
  else
	convert(stdin);

  exit(0);
}

convert(fp) FILE *fp;
{
  static int bit[] = { 128, 64, 32, 16, 8, 4, 2, 1 };
  int total, width, height, maxcolor;
  int byte, i, j, k, n, r, g, b, wb, wr, tl;

  if (fgets(buf, BUFSIZ, fp) == NULL)
	error("illegal input file format", (char *)0);
  if (strncmp(buf, "P3", 2) != 0)
	error("unsupported file format: %.2s", buf);
  if (fgets(buf, BUFSIZ, fp) == NULL)
	error("illegal input file format", (char *)0);
  width = height = 0;
  sscanf(buf, "%d %d", &width, &height);
  if (fgets(buf, BUFSIZ, fp) == NULL)
	error("illegal input file format", (char *)0);
  maxcolor = 0;
  sscanf(buf, "%d", &maxcolor);
  tl = maxcolor / 2;
  wb = n = width / 8;
  wr = width % 8;
  if (wr)
	n++;
  n += lmargin;
  fprintf(stdout, "\r\033[%d;%d;%d;0;%d.r", n * height, n, mag, height);
  for (i = 0; i < height; i++) {
	byte = 0;
	for (k = 0; k < lmargin; k++)
		fprintf(stdout, "%c", byte);
	for (j = 0; j < wb; j++) {
		byte = 0;
		for (k = 0; k < 8; k++) {
			fscanf(fp, " %d %d %d", &r, &g, &b);
			if (r < tl && g < tl && b < tl)
				byte |= bit[k];
		}
		fprintf(stdout, "%c", byte);
	}
	byte = 0;
	for (k = 0; k < wr; k++) {
		fscanf(fp, " %d %d %d", &r, &g, &b);
		if (r < tl && g < tl && b < tl)
			byte |= bit[k];
	}
	fprintf(stdout, "%c", byte);
  }
  if (fflg)
	fprintf(stdout, "\f");

  while (fgets(buf, BUFSIZ, fp) != NULL)
	if (*buf != '\n' && *(buf+1) != '\0')
		error("too many data", (char *)0);
}

FILE *
efopen(file, mode) char *file, *mode;
{
  FILE *fp;

  if ((fp = fopen(file, mode)) == NULL)
	error("can't open %s", file);
  return fp;
}

error(s, t) char *s, *t;
{
  fprintf(stderr, "%s: ", cmd);
  fprintf(stderr, s, t);
  fprintf(stderr, "\n");
  exit(1);
}

Usage()
{
  static char *t[] = {
"ޥ	pnmtolps - PNM  CANON LISP ؤѴ",
"ʸ		pnmtolips [ץ] [ե]",
"ץ	-M 	# ٤ (ǥեȤ 300dpi)",
"		-f		# եࡦեɤϤʤ",
"		-m ޡ	# ޡɥåȿǻ",
"		pnmtolips <in >out	# in ե out եѴ",
"		xwd | xwdtopnm | pnmtolips >/dev/lpt0",
"	PNM Υ᡼ǡ LIPS Υ饹᡼(Хʥ)",
"ѴޤϥǡϤΤޤޥץ󥿤Ϥ褦ˤʤäƤơǥե",
"ȤǤ 104 ɥåʬκޡȤꡢϥǡκǸ˥եࡦե",
" (FF) դޤѻʣΥ᡼ǡ᡼",
"ǡκǸ˥եࡦե (FF) Ϥʤ -f ץ"
"ꤷޤޡϥɥåȿǻꤷޤ8 ɥåȤǳä;",
"ڼΤƤޤºݤϥץ󥿤β٤ˤäѲޤΤդ",
"٤λǳΨޤޤϥץ󥿤ˤäưۤʤꡢ",
"Τ褦ˤʤޤ",
"  LIPS2, LIPS2++:",
"    Ψ (m)",
"       1   120<m",
"       2    80<m<=120",
"       3    60<m<=80",
"       4       M<=60",
"  LIPS4, LIPS4:",
"    Ψ = 300/",
  NULL
  };
  int i;

  for (i = 0; t[i] != NULL; i++)
	fprintf(stderr, "%s\n", t[i]);
}
